<?php
 
class bNamed_conn
{
    var $BaseUrl = "https://www2.bNamed.net/nl/api.asp?";
	var $ConnUrl = '';
	var $RequestResponse = '';
	var $ParsedResponse = '';
	
	function CreateConnUrl($uid,$key)
	{
		$this->ConnUrl = $this->BaseUrl."uid=".$uid."&key=".$key;
	}
	
	function AddParam($name, $value)
	{
		$this->ConnUrl .= "&".$name."=".urlencode($value);
	}
	
	function SendRequest()
	{
			$this->RequestResponse = file_get_contents($this->ConnUrl);
			$this->ParsedResponse = simplexml_load_string($this->RequestResponse);
	}
}

function bnamed_getConfigArray() {
	$configarray = array(
	 "UID" => array( "Type" => "text", "Size" => "20", "Description" => "Enter your bNamed UID here", ),
	 "Key" => array( "Type" => "password", "Size" => "20", "Description" => "Enter your bNamed Key here", ),
	 "Nameserver1" => array( "Type" => "text", "Size" => "20", "Description" => "(default nameserver 1)", ),
	 "Nameserver2" => array( "Type" => "text", "Size" => "20", "Description" => "(default nameserver 2)", ),
	 "Nameserver3" => array( "Type" => "text", "Size" => "20", "Description" => "(default nameserver 3)", ),
	 "Nameserver4" => array( "Type" => "text", "Size" => "20", "Description" => "(default nameserver 4)", ),
	);
	return $configarray;
}

function bnamed_GetNameservers($params) {

	$username = $params["UID"];
	$password = $params["Key"];
	$testmode = $params["TestMode"];
	$tld = $params["tld"];
	$sld = $params["sld"];
	
	$bNamed = new bNamed_conn();

	$bNamed->CreateConnUrl($username,$password);
	$bNamed->AddParam("command","GetDomain");
	$bNamed->AddParam("sld",$sld);
	$bNamed->AddParam("tld",$tld);
	
	$bNamed->SendRequest();
		
	$nameservers = explode(",",$bNamed->ParsedResponse->Result->DNSList);
	
	if($bNamed->ParsedResponse->ErrorCode > 0)
	{
		$error = $bNamed->ParsedResponse->ErrorText." ( ErrorCode = ".$bNamed->ParsedResponse->ErrorCode." )";
	}
	else
	{
		$values["ns1"] = $nameservers[0];
		$values["ns2"] = $nameservers[1];
		$values["ns3"] = $nameservers[2];
		$values["ns4"] = $nameservers[3];
	}
		
	$values["error"] = $error;
	return $values;
}

function bnamed_SaveNameservers($params) {

	$username = $params["UID"];
	$password = $params["Key"];
	$testmode = $params["TestMode"];
	$tld = $params["tld"];
	$sld = $params["sld"];
    $nameserver1 = $params["ns1"];
	$nameserver2 = $params["ns2"];
    $nameserver3 = $params["ns3"];
	$nameserver4 = $params["ns4"];

	$dnslist = $params["ns1"];
	if($params["ns2"] != '') $dnslist .= ",".$params["ns2"];
	if($params["ns3"] != '') $dnslist .= ",".$params["ns3"];
	if($params["ns4"] != '') $dnslist .= ",".$params["ns4"];
	
	$bNamed = new bNamed_conn();
	
	$bNamed->CreateConnUrl($username,$password);
	$bNamed->AddParam("command","Update");
	$bNamed->AddParam("sld",$sld);
	$bNamed->AddParam("tld",$tld);
	$bNamed->AddParam("dnstype","E");
	$bNamed->AddParam("dnslist",$dnslist);

	$bNamed->SendRequest();
	
	if($bNamed->ParsedResponse->ErrorCode > 0)
	{
		$error = $bNamed->ParsedResponse->ErrorText." ( ErrorCode = ".$bNamed->ParsedResponse->ErrorCode." )";
	}
		
	$values["error"] = $error;
	return $values;
}

function bnamed_GetRegistrarLock($params) {
    $values["error"] = "Contact us via e-mail if you want to update the registrar lock";
    return $values;
}

function bnamed_SaveRegistrarLock($params) {
    $values["error"] = "Contact us via e-mail if you want to update the registrar lock";
    return $values;
}

function bnamed_GetEmailForwarding($params) {
    $values["error"] = "function ".__FUNCTION__." not available";
    return $values;
}

function bnamed_SaveEmailForwarding($params) {
    $values["error"] = "function ".__FUNCTION__." not available";
    return $values;
}

function bnamed_GetDNS($params) {
    $values["error"] = "function ".__FUNCTION__." not available";
    return $values;
}

function bnamed_SaveDNS($params) {
    $values["error"] = "function ".__FUNCTION__." not available";
    return $values;
}

function bnamed_RegisterDomain($params) {

	$username = $params["UID"];
	$password = $params["Key"];
	$testmode = $params["TestMode"];
	$tld = $params["tld"];
	$sld = $params["sld"];
	$regperiod = $params["regperiod"];
	$nameserver1 = $params["ns1"];
	$nameserver2 = $params["ns2"];
    $nameserver3 = $params["ns3"];
    $nameserver4 = $params["ns4"];

	$bNamed = new bNamed_conn();
	
	$bNamed->CreateConnUrl($username,$password);
	$bNamed->AddParam("command","purchase");
	$bNamed->AddParam("sld",$sld);
	$bNamed->AddParam("tld",$tld);
	$bNamed->AddParam("PurchaseType","N");

	$address_arr = explode(" ",$params["address1"]);
	$nr = $address_arr[count($address_arr)-1];
	$street = '';
	for($i=0;$i<count($address_arr)-1;$i++)
	{
		$street .= $address_arr[$i];
	}
	$bNamed->AddParam("LicenseeNr","-2");
	$bNamed->AddParam("LicenseeFirstName",$params["firstname"]);
	$bNamed->AddParam("LicenseeName",$params["lastname"]);
	$bNamed->AddParam("LicenseeStreet",$street);
	$bNamed->AddParam("LicenseeStreetNr",$nr);
	$bNamed->AddParam("LicenseePostCode",$params["postcode"]);
	$bNamed->AddParam("LicenseeResidence",$params["city"]);
	$bNamed->AddParam("LicenseeCountry",$params["country"]);
	$bNamed->AddParam("LicenseePhone",$params["phonenumber"]);
	$bNamed->AddParam("LicenseeEMail",$params["email"]);
	$bNamed->AddParam("LicenseeCompany",$params["companyname"]);
	
	$address_arr = explode(" ",$params["adminaddress1"]);
	$nr = $address_arr[count($address_arr)-1];
	$street = '';
	for($i=0;$i<count($address_arr)-1;$i++)
	{
		$street .= $address_arr[$i];
	}
	$bNamed->AddParam("OnSiteNr","-2");
	$bNamed->AddParam("OnSiteFirstName",$params["adminfirstname"]);
	$bNamed->AddParam("OnSiteName",$params["adminlastname"]);
	$bNamed->AddParam("OnSiteStreet",$street);
	$bNamed->AddParam("OnSiteStreetNr",$nr);
	$bNamed->AddParam("OnSitePostCode",$params["adminpostcode"]);
	$bNamed->AddParam("OnSiteResidence",$params["admincity"]);
	$bNamed->AddParam("OnSiteCountry",$params["admincountry"]);
	$bNamed->AddParam("OnSitePhone",$params["adminphonenumber"]);
	$bNamed->AddParam("OnSiteEMail",$params["adminemail"]);
	$bNamed->AddParam("OnSiteCompany",$params["admincompanyname"]);
	
	$bNamed->AddParam("NumYears",$regperiod);
	$bNamed->AddParam("DNSType","E");
	$bNamed->AddParam("DNSList",$nameserver1.",".$nameserver2);
	
	$bNamed->ConnUrl = str_replace(" ","%20",$bNamed->ConnUrl);
	
	$bNamed->SendRequest();
	
	if($bNamed->ParsedResponse->ErrorCode > 0)
	{
		$error = $bNamed->ParsedResponse->ErrorText." ( ErrorCode = ".$bNamed->ParsedResponse->ErrorCode." )";
	}
	
	$values["error"] = $error;
	return $values;
}

function bnamed_TransferDomain($params) {

	$username = $params["UID"];
	$password = $params["Key"];
	$testmode = $params["TestMode"];
	$tld = $params["tld"];
	$sld = $params["sld"];
	$regperiod = $params["regperiod"];
	$nameserver1 = $params["ns1"];
	$nameserver2 = $params["ns2"];
    $nameserver3 = $params["ns3"];
    $nameserver4 = $params["ns4"];

	$RegistrantFirstName = $params["firstname"];
	$RegistrantLastName = $params["lastname"];
	$RegistrantCompanyName = $params["companyname"];
	$RegistrantAddress1 = $params["address1"];
	$RegistrantAddress2 = $params["address2"];
	$RegistrantCity = $params["city"];
	$RegistrantStateProvince = $params["state"];
	$RegistrantPostalCode = $params["postcode"];
	$RegistrantCountry = $params["country"];
	$RegistrantEmailAddress = $params["email"];
	$RegistrantPhone = $params["phonenumber"];

	$AdminFirstName = $params["adminfirstname"];
	$AdminLastName = $params["adminlastname"];
	$AdminAddress1 = $params["adminaddress1"];
	$AdminAddress2 = $params["adminaddress2"];
	$AdminCity = $params["admincity"];
	$AdminStateProvince = $params["adminstate"];
	$AdminPostalCode = $params["adminpostcode"];
	$AdminCountry = $params["admincountry"];
	$AdminEmailAddress = $params["adminemail"];
	$AdminPhone = $params["adminphonenumber"];

	$bNamed = new bNamed_conn();

	$bNamed->CreateConnUrl($username,$password);
	$bNamed->AddParam("command","purchase");
	$bNamed->AddParam("sld",$sld);
	$bNamed->AddParam("tld",$tld);
	$bNamed->AddParam("PurchaseType","B");

	if($params["customfields2"] && $params["customfields2"] != "")	
	{
		$bNamed->AddParam("LicenseeNr",$params["customfields2"]);
	}
	else
	{
		$address_arr = explode(" ",$RegistrantAddress1);
		$nr = $address_arr[count($address_arr)-1];
		$street = '';
		for($i=0;$i<count($address_arr)-1;$i++)
		{
			$street .= $address_arr[$i];
		}
		$bNamed->AddParam("LicenseeNr","0");
		$bNamed->AddParam("LicenseeFirstName",$RegistrantFirstName);
		$bNamed->AddParam("LicenseeName",$RegistrantLastName);
		$bNamed->AddParam("LicenseeStreet",$street);
		$bNamed->AddParam("LicenseeStreetNr",$nr);
		$bNamed->AddParam("LicenseePostCode",$RegistrantPostalCode);
		$bNamed->AddParam("LicenseeResidence",$RegistrantCity);
		$bNamed->AddParam("LicenseeCountry",$RegistrantCountry);
		$bNamed->AddParam("LicenseePhone",$RegistrantPhone);
		if($RegistrantCountry == "BE") $cc = "32";
		elseif($RegistrantCountry == "NL") $cc = "31";
		else $cc = "00";
		$bNamed->AddParam("LicenseeCountryCode",$cc);
		$bNamed->AddParam("LicenseeEMail",$RegistrantEmailAddress);
		$bNamed->AddParam("LicenseeCompany",$RegistrantCompanyName);
	}
	$bNamed->AddParam("OnSiteNr",$params["UID"]);
	$bNamed->AddParam("NumYears",$regperiod);
	$bNamed->AddParam("DNSType","E");
	if($params["transfersecret"] != '') $bNamed->AddParam("AuthKey",$params["transfersecret"]);
	$bNamed->AddParam("DNSList",$nameserver1.",".$nameserver2);
	
	$bNamed->SendRequest();
	
	if($bNamed->ParsedResponse->ErrorCode > 0)
	{
		$error = $bNamed->ParsedResponse->ErrorText." ( ErrorCode = ".$bNamed->ParsedResponse->ErrorCode." )";
	}
	if($bNamed->ParsedResponse->ErrorCode == "209") echo "Controleer het telefoonnummer";	

	$values["error"] = $error;
	return $values;
}

function bnamed_RenewDomain($params) {

	$username = $params["UID"];
	$password = $params["Key"];
	$testmode = $params["TestMode"];
	$tld = $params["tld"];
	$sld = $params["sld"];
	$regperiod = $params["regperiod"];

	$bNamed = new bNamed_conn();

	$bNamed->CreateConnUrl($username,$password);
	$bNamed->AddParam("command","extend");
	$bNamed->AddParam("sld",$sld);
	$bNamed->AddParam("tld",$tld);
	$bNamed->AddParam("NumYears",$regperiod);

	$bNamed->SendRequest();
	
	if($bNamed->ParsedResponse->ErrorCode > 0)
	{
		$error = $bNamed->ParsedResponse->ErrorText." ( ErrorCode = ".$bNamed->ParsedResponse->ErrorCode." )";
	}
	if($bNamed->ParsedResponse->ErrorCode == "209") echo "Invalid phone number";	

	$values["error"] = $error;
	return $values;
}

function bnamed_GetContactDetails($params) {

	$username = $params["UID"];
	$password = $params["Key"];
	$testmode = $params["TestMode"];
	$tld = $params["tld"];
	$sld = $params["sld"];
	
	$bNamed = new bNamed_conn();

	$bNamed->CreateConnUrl($username,$password);
	$bNamed->AddParam("command","GetDomain");
	$bNamed->AddParam("sld",$sld);
	$bNamed->AddParam("tld",$tld);

	$bNamed->SendRequest();
	
	$values["Registrant"]["First Name"] = $bNamed->ParsedResponse->Result->Licensee->FirstName;
	$values["Registrant"]["Last Name"] = $bNamed->ParsedResponse->Result->Licensee->Name;
	$values["Registrant"]["Company"] = $bNamed->ParsedResponse->Result->Licensee->Company;
	$values["Registrant"]["Address"] = $bNamed->ParsedResponse->Result->Licensee->Street;
	$values["Registrant"]["Postcode"] = $bNamed->ParsedResponse->Result->Licensee->Postcode;
	$values["Registrant"]["City"] = $bNamed->ParsedResponse->Result->Licensee->Residence;
	$values["Registrant"]["Country"] = $bNamed->ParsedResponse->Result->Licensee->Country;
	$values["Registrant"]["Phone"] = $bNamed->ParsedResponse->Result->Licensee->Phone;
	$values["Registrant"]["E-mail"] = $bNamed->ParsedResponse->Result->Licensee->EMail;
	$values["Registrant"]["Fax"] = $bNamed->ParsedResponse->Result->Licensee->Fax;

	$values["Tech"]["First Name"] = $bNamed->ParsedResponse->Result->OnSite->FirstName;
	$values["Tech"]["Last Name"] = $bNamed->ParsedResponse->Result->OnSite->Name;
	$values["Tech"]["Company"] = $bNamed->ParsedResponse->Result->OnSite->Company;
	$values["Tech"]["Address"] = $bNamed->ParsedResponse->Result->OnSite->Street;
	$values["Tech"]["Postcode"] = $bNamed->ParsedResponse->Result->OnSite->Postcode;
	$values["Tech"]["City"] = $bNamed->ParsedResponse->Result->OnSite->Residence;
	$values["Tech"]["Country"] = $bNamed->ParsedResponse->Result->OnSite->Country;
	$values["Tech"]["Phone"] = $bNamed->ParsedResponse->Result->OnSite->Phone;
	$values["Tech"]["E-mail"] = $bNamed->ParsedResponse->Result->OnSite->EMail;
	$values["Tech"]["Fax"] = $bNamed->ParsedResponse->Result->OnSite->Fax;

    return $values;
}

function bnamed_SaveContactDetails($params) {

	$username = $params["UID"];
	$password = $params["Key"];
	$testmode = $params["TestMode"];
	$tld = $params["tld"];
	$sld = $params["sld"];
	$regperiod = $params["regperiod"];
	$nameserver1 = $params["ns1"];
	$nameserver2 = $params["ns2"];
    $nameserver3 = $params["ns3"];
    $nameserver4 = $params["ns4"];

	$bNamed = new bNamed_conn();
	
	$bNamed->CreateConnUrl($username,$password);
	$bNamed->AddParam("command","update");
	$bNamed->AddParam("sld",$sld);
	$bNamed->AddParam("tld",$tld);

	$address_arr = explode(" ",$params["contactdetails"]["Registrant"]["Address"]);
	$nr = $address_arr[count($address_arr)-1];
	$street = '';
	for($i=0;$i<count($address_arr)-1;$i++)
	{
		$street .= $address_arr[$i];
	}
	$bNamed->AddParam("LicenseeNr","-2");
	$bNamed->AddParam("LicenseeFirstName",$params["contactdetails"]["Registrant"]["First Name"]);
	$bNamed->AddParam("LicenseeName",$params["contactdetails"]["Registrant"]["Last Name"]);
	$bNamed->AddParam("LicenseeStreet",$street);
	$bNamed->AddParam("LicenseeStreetNr",$nr);
	$bNamed->AddParam("LicenseePostCode",$params["contactdetails"]["Registrant"]["Postcode"]);
	$bNamed->AddParam("LicenseeResidence",$params["contactdetails"]["Registrant"]["City"]);
	$bNamed->AddParam("LicenseeCountry",$params["contactdetails"]["Registrant"]["Country"]);
	$bNamed->AddParam("LicenseePhone",$params["contactdetails"]["Registrant"]["Phone"]);
	$bNamed->AddParam("LicenseeEMail",$params["contactdetails"]["Registrant"]["E-mail"]);
	$bNamed->AddParam("LicenseeCompany",$params["contactdetails"]["Registrant"]["Company"]);
	
	$address_arr = explode(" ",$params["contactdetails"]["Tech"]["Address"]);
	$nr = $address_arr[count($address_arr)-1];
	$street = '';
	for($i=0;$i<count($address_arr)-1;$i++)
	{
		$street .= $address_arr[$i];
	}
	$bNamed->AddParam("OnSiteNr","-2");
	$bNamed->AddParam("OnSiteFirstName",$params["contactdetails"]["Tech"]["First Name"]);
	$bNamed->AddParam("OnSiteName",$params["contactdetails"]["Tech"]["Last Name"]);
	$bNamed->AddParam("OnSiteStreet",$street);
	$bNamed->AddParam("OnSiteStreetNr",$nr);
	$bNamed->AddParam("OnSitePostCode",$params["contactdetails"]["Tech"]["Postcode"]);
	$bNamed->AddParam("OnSiteResidence",$params["contactdetails"]["Tech"]["City"]);
	$bNamed->AddParam("OnSiteCountry",$params["contactdetails"]["Tech"]["Country"]);
	$bNamed->AddParam("OnSitePhone",$params["contactdetails"]["Tech"]["Phone"]);
	$bNamed->AddParam("OnSiteEMail",$params["contactdetails"]["Tech"]["E-mail"]);
	$bNamed->AddParam("OnSiteCompany",$params["contactdetails"]["Tech"]["Company"]);
	
	$bNamed->ConnUrl = str_replace(" ","%20",$bNamed->ConnUrl);
	
	$bNamed->SendRequest();
	
	if($bNamed->ParsedResponse->ErrorCode > 0)
	{
		$error = $bNamed->ParsedResponse->ErrorText." ( ErrorCode = ".$bNamed->ParsedResponse->ErrorCode." )";
	}
	
	$values["error"] = $error;
	return $values;
}

function bnamed_GetEPPCode($params) {
    $values["error"] = "Contact us via e-mail to receive your authorization key";
    return $values;
}

function bnamed_RegisterNameserver($params) {
    $values["error"] = "Registering your nameserver will be carried out automatically the first time you use it";
    return $values;
}

function bnamed_ModifyNameserver($params) {
    $values["error"] = "Please contact us via e-mail to update the IP-address of a nameserver";
    return $values;
}

function bnamed_DeleteNameserver($params) {
    $values["error"] = "function ".__FUNCTION__." not available";
    return $values;
}

?>